reSIDfp::Filter Class Referenceabstract

`#include <Filter.h>`

Inheritance diagram for reSIDfp::Filter:

## Public Member Functions

virtual unsigned short | clock (int v1, int v2, int v3)=0
void | enable (bool enable)
void | reset ()
void | writeFC_LO (unsigned char fc_lo)
void | writeFC_HI (unsigned char fc_hi)
void | writeRES_FILT (unsigned char res_filt)
void | writeMODE_VOL (unsigned char mode_vol)
virtual void | input (int input)=0

## Protected Member Functions

virtual void | updatedCenterFrequency ()=0
virtual void | updateResonance (unsigned char res)=0
virtual void | updatedMixing ()=0

## Protected Attributes

unsigned short * | currentGain
| Current volume amplifier setting.
unsigned short * | currentMixer
| Current filter/voice mixer setting.
unsigned short * | currentSummer
| Filter input summer setting.
unsigned short * | currentResonance
| Filter resonance value.
int | Vhp
| Filter highpass state.
int | Vbp
| Filter bandpass state.
int | Vlp
| Filter lowpass state.
int | ve
| Filter external input.
unsigned int | fc
| Filter cutoff frequency.
bool | filt1
| Routing to filter or outside filter.
bool | filt2
bool | filt3
bool | filtE
bool | voice3off
| Switch voice 3 off.
bool | hp
| Highpass, bandpass, and lowpass filter modes.
bool | bp
bool | lp
unsigned char | vol
| Current volume.

## Detailed Description

SID filter base class

## Member Function Documentation

## clock()

virtual unsigned short reSIDfp::Filter::clock | ( | int | v1,
|  | int | v2,
|  | int | v3
| ) |  |

pure virtual

SID clocking - 1 cycle

Parameters

  v1 | voice 1 in
  v2 | voice 2 in
  v3 | voice 3 in

Returns
  filtered output

Implemented in reSIDfp::Filter6581.

## enable()

void reSIDfp::Filter::enable | ( | bool | enable | ) |

Enable filter.

Parameters

  enable |

## reset()

void reSIDfp::Filter::reset | ( |  | ) |

SID reset.

## updatedCenterFrequency()

virtual void reSIDfp::Filter::updatedCenterFrequency | ( |  | ) |

protected pure virtual

Set filter cutoff frequency.

Implemented in reSIDfp::Filter6581.

## updatedMixing()

virtual void reSIDfp::Filter::updatedMixing | ( |  | ) |

protected pure virtual

Mixing configuration modified (offsets change)

Implemented in reSIDfp::Filter6581.

## updateResonance()

virtual void reSIDfp::Filter::updateResonance | ( | unsigned char | res | ) |

protected pure virtual

Set filter resonance.

Implemented in reSIDfp::Filter6581.

## writeFC_HI()

void reSIDfp::Filter::writeFC_HI | ( | unsigned char | fc_hi | ) |

Write Frequency Cutoff High register.

Parameters

  fc_hi | Frequency Cutoff High-Byte

## writeFC_LO()

void reSIDfp::Filter::writeFC_LO | ( | unsigned char | fc_lo | ) |

Write Frequency Cutoff Low register.

Parameters

  fc_lo | Frequency Cutoff Low-Byte

## writeMODE_VOL()

void reSIDfp::Filter::writeMODE_VOL | ( | unsigned char | mode_vol | ) |

Write filter Mode/Volume register.

Parameters

  mode_vol | Filter Mode/Volume

## writeRES_FILT()

void reSIDfp::Filter::writeRES_FILT | ( | unsigned char | res_filt | ) |

Write Resonance/Filter register.

Parameters

  res_filt | Resonance/Filter

The documentation for this class was generated from the following files:

- Filter.h
- Filter.cpp